#Initialize Constants
scoreboard players set #256 clgd.cauldron.color 256
scoreboard players set #2 clgd.cauldron.color 2

#Split color1 into RGB components
scoreboard players operation $B1 clgd.cauldron.color = $Color1 clgd.cauldron.color
scoreboard players operation $B1 clgd.cauldron.color %= #256 clgd.cauldron.color
scoreboard players operation $Color1 clgd.cauldron.color /= #256 clgd.cauldron.color

scoreboard players operation $G1 clgd.cauldron.color = $Color1 clgd.cauldron.color
scoreboard players operation $G1 clgd.cauldron.color %= #256 clgd.cauldron.color
scoreboard players operation $Color1 clgd.cauldron.color /= #256 clgd.cauldron.color

scoreboard players operation $R1 clgd.cauldron.color = $Color1 clgd.cauldron.color

#Split color2 into RGB components
scoreboard players operation $B2 clgd.cauldron.color = $Color2 clgd.cauldron.color
scoreboard players operation $B2 clgd.cauldron.color %= #256 clgd.cauldron.color
scoreboard players operation $Color2 clgd.cauldron.color /= #256 clgd.cauldron.color

scoreboard players operation $G2 clgd.cauldron.color = $Color2 clgd.cauldron.color
scoreboard players operation $G2 clgd.cauldron.color %= #256 clgd.cauldron.color
scoreboard players operation $Color2 clgd.cauldron.color /= #256 clgd.cauldron.color

scoreboard players operation $R2 clgd.cauldron.color = $Color2 clgd.cauldron.color

#Average the RGB of both colors
scoreboard players operation $RFinal clgd.cauldron.color = $R1 clgd.cauldron.color
scoreboard players operation $RFinal clgd.cauldron.color += $R2 clgd.cauldron.color
scoreboard players operation $RFinal clgd.cauldron.color /= #2 clgd.cauldron.color

scoreboard players operation $GFinal clgd.cauldron.color = $G1 clgd.cauldron.color
scoreboard players operation $GFinal clgd.cauldron.color += $G2 clgd.cauldron.color
scoreboard players operation $GFinal clgd.cauldron.color /= #2 clgd.cauldron.color

scoreboard players operation $BFinal clgd.cauldron.color = $B1 clgd.cauldron.color
scoreboard players operation $BFinal clgd.cauldron.color += $B2 clgd.cauldron.color
scoreboard players operation $BFinal clgd.cauldron.color /= #2 clgd.cauldron.color


#Find the largest component of each color
scoreboard players operation $Max1 clgd.cauldron.color = $R1 clgd.cauldron.color
execute if score $G1 clgd.cauldron.color > $Max1 clgd.cauldron.color run scoreboard players operation $Max1 clgd.cauldron.color = $G1 clgd.cauldron.color
execute if score $B1 clgd.cauldron.color > $Max1 clgd.cauldron.color run scoreboard players operation $Max1 clgd.cauldron.color = $B1 clgd.cauldron.color

scoreboard players operation $Max2 clgd.cauldron.color = $R2 clgd.cauldron.color
execute if score $G2 clgd.cauldron.color > $Max2 clgd.cauldron.color run scoreboard players operation $Max2 clgd.cauldron.color = $G2 clgd.cauldron.color
execute if score $B2 clgd.cauldron.color > $Max2 clgd.cauldron.color run scoreboard players operation $Max2 clgd.cauldron.color = $B2 clgd.cauldron.color

scoreboard players operation $MaxFinal clgd.cauldron.color = $RFinal clgd.cauldron.color
execute if score $GFinal clgd.cauldron.color > $MaxFinal clgd.cauldron.color run scoreboard players operation $MaxFinal clgd.cauldron.color = $GFinal clgd.cauldron.color
execute if score $BFinal clgd.cauldron.color > $MaxFinal clgd.cauldron.color run scoreboard players operation $MaxFinal clgd.cauldron.color = $BFinal clgd.cauldron.color


#Sum the max component of the input colors
scoreboard players operation $SumMax clgd.cauldron.color = $Max1 clgd.cauldron.color
scoreboard players operation $SumMax clgd.cauldron.color += $Max2 clgd.cauldron.color

#Multiply the max component of the average
scoreboard players operation $MaxFinal clgd.cauldron.color *= #2 clgd.cauldron.color

#Calculate final RGB values
scoreboard players operation $RFinal clgd.cauldron.color *= $SumMax clgd.cauldron.color
scoreboard players operation $RFinal clgd.cauldron.color /= $MaxFinal clgd.cauldron.color

scoreboard players operation $GFinal clgd.cauldron.color *= $SumMax clgd.cauldron.color
scoreboard players operation $GFinal clgd.cauldron.color /= $MaxFinal clgd.cauldron.color

scoreboard players operation $BFinal clgd.cauldron.color *= $SumMax clgd.cauldron.color
scoreboard players operation $BFinal clgd.cauldron.color /= $MaxFinal clgd.cauldron.color

#Convert RGB to int
scoreboard players operation $ColorOut clgd.cauldron.color = $RFinal clgd.cauldron.color
scoreboard players operation $ColorOut clgd.cauldron.color *= #256 clgd.cauldron.color
scoreboard players operation $ColorOut clgd.cauldron.color += $GFinal clgd.cauldron.color
scoreboard players operation $ColorOut clgd.cauldron.color *= #256 clgd.cauldron.color
scoreboard players operation $ColorOut clgd.cauldron.color += $BFinal clgd.cauldron.color


#Clean up
scoreboard players reset $Color1 clgd.cauldron.color
scoreboard players reset $Color2 clgd.cauldron.color
scoreboard players reset $Max1 clgd.cauldron.color
scoreboard players reset $Max2 clgd.cauldron.color
scoreboard players reset $MaxFinal clgd.cauldron.color
scoreboard players reset $SumMax clgd.cauldron.color
scoreboard players reset $R1 clgd.cauldron.color
scoreboard players reset $R2 clgd.cauldron.color
scoreboard players reset $RFinal clgd.cauldron.color
scoreboard players reset $G1 clgd.cauldron.color
scoreboard players reset $G2 clgd.cauldron.color
scoreboard players reset $GFinal clgd.cauldron.color
scoreboard players reset $B1 clgd.cauldron.color
scoreboard players reset $B2 clgd.cauldron.color
scoreboard players reset $BFinal clgd.cauldron.color